/**
   
 */
/*  2000 Serge Rosmorduc,
 * quipe EC.art, Laboratoire LRIA, Universit de Paris 8
 *
 * 15 rue Catulienne
 * 93236 St Denis Cedex
 * FRANCE
 *
 * Tout droits rservs.
 * 
 * voyez le fichier ../LICENCE.txt pour plus d'informations
 * See the ../LICENCEE.txt file for more information
 *
 * $Id$
 *
 */

/*
 * $Log$
 */

#ifndef EXPRBUILDER_H
#define EXPRBUILDER_H

#include "ExprTokeniser.h"
#include "Expr.h"
#include "Rule.h"

class SyntaxError {
 public:
  SyntaxError(const string & msg) : message(msg) {};
  const string & getMessage() {return message;}
 private:
  string message;
};

class SimpleExprBuilder {
 public:
  SimpleExprBuilder();
  Rule * makeRule(string s);
  Rule * makeRule(istream & s);
  PlainExpr * makePlainExpr(string s);
  PlainExpr * makePlainExpr(istream &s);
 private:
  
  ExprTokeniser *t;
  Bindings *bindings;
  Rule * currentRule;
  VarTable * varTable;

  FuncExpr *
    parseFunc();
  
  PlainExpr *
    parseItem();

  PlainExpr *
    parseLeftItem();

  
  PlainExpr *
    parseAtom();

  VarExpr *
    parseVar();

  list<Expr *> *
    parseItems();
    
  list<PlainExpr *> *
    parseTerms();

  list<PlainExpr *> * 
    parseArgs();

  AndExpr *
    parseAndExpr();
    
  Rule *
    parseRule();
};

#endif
