/**
   
 */
/*  2000 Serge Rosmorduc,
 * quipe EC.art, Laboratoire LRIA, Universit de Paris 8
 *
 * 15 rue Catulienne
 * 93236 St Denis Cedex
 * FRANCE
 *
 * Tout droits rservs.
 * 
 * voyez le fichier ../LICENCE.txt pour plus d'informations
 * See the ../LICENCEE.txt file for more information
 *
 * $Id$
 *
 */

/*
 * $Log$
 */

class State {
 public:
  // Returns an arc, compatible with a and the present state.
  // Remember that rules are deterministic for a given input.
  State * next(Arc *a);
 private:
  // A) a binding table.
  Bindings *b;
  // B) a position in the rule.
  RuleItem *ruleitem;
}

Arc * 
state::next(arc *a)
{
  Arc * res;
  if (getExpr().match(a))
    {
      // We build a new Arc, which leads to a new RuleNode
      // The Arc labels are : a->getUp() and ...
      // The new node is created with a state
      // which corresponds to the next item in the rule,
      // and a binding which corresponds to the binding obtained
      // by match 
      state *nextState= new state(getRuleItem()->getNext(), 
				  getExpr()->getNextBindings());
      RuleNode * nextNode= new RuleNode(nextState);
      Expr nextDown= new Expr(getRuleItem()->getDown(), nextState->getBindings());
      // Calculation of value function. +, max, min, * ????
      nextValue= a->getValue() + getRuleItem()->getValue();
      res= new RuleArc(a.getUp(), nextDown, nextValue, nextNode);
    }
  else
    res= 0;
  return res;
}
