// Test file for Transducer functions.
//

#include "Transducer.h"
#include <iostream>

int
main()
{
  try {
    // Create an Entry Transducer
    EntryTransducer a0;
    EntryNode * n0= a0.getTrueStart();
    EntryNode * n1= a0.makeNodeByLabel(1);
    //  ir:r-A1
    n0->addLink(n1, "ir", "P(i,r)");
    // Autre solution : 
    // a0.addLink(n0, n1, "ir -> P(i,r)");

    n0= n1;
    n1= a0.makeNodeByLabel(2);
    n0->addLink(n1, "r", "P(r)");

    n0= n1;
    n1= a0.makeNodeByLabel(3);
    n0->addLink(n1, "A1", "S(A1)");
    n0->addLink(n1, "A1", "D(homme)");

    n0= n1;
    n1= a0.makeNodeByLabel(4);
    // n0->addLink(n1, "A1", "P(iot)");
    n0->addLink(n1, "epsilon", "SEP(W)");
    n1->setFinal(true);

    cout << a0 << endl;

    // Create a rule Transducer
    RuleTransducer a3;
    RuleNode * rn0= a3.getStart();
    RuleNode * rn1= a3.makeNodeByLabel(1);
    RuleNode * rn2= a3.makeNodeByLabel(2);
    rn0->addLink(rn0, "SEP($X) -> SEP($X)");
    rn0->addLink(rn1, "$A & ! SEP($X) -> $A");
    rn1->addLink(rn1, "$A & ! SEP($X) -> SEP(S), $A");
    rn1->addLink(rn1, "$A & ! SEP($X) -> SEP(W), $A");
    rn1->addLink(rn0, "SEP($X) -> SEP($X)");
    rn1->addLink(rn2, "epsilon -> epsilon");
    rn0->addLink(rn2, "epsilon -> epsilon");
    rn2->setFinal(true);
    
    // Create a rule Transducer
    RuleTransducer a1;
    rn0= a1.getStart();
    rn0->setFinal(true);
  
    rn0->addLink(rn0, "P($X,$Y), SEP(S), P($Y) -> L($X), SEP(S), L($Y) / 100");
    rn0->addLink(rn0, "P($X,$Y) -> L($X), L($Y) / 200");
    rn0->addLink(rn0, "P($Y) -> L($Y) / 300");
    rn0->addLink(rn0, "SEP(S), S(A1), SEP(W) -> SEP(GRAM), L(i), SEP(W) / 20");
    rn0->addLink(rn0, "SEP($Y) -> SEP($Y)");
    rn0->addLink(rn0, "D($V), SEP(W) -> SEP(MOT) / 50");
    
    // Apply
    CompositeTransducer a4(&a0,&a3);
    CompositeTransducer a2(&a4,&a1);
    // See the resulting transducer
    cout << "==================================================" << endl;
    cout << a4 << endl;
    cout << "==================================================" << endl;
    cout << "==================================================" << endl;
    cout << a2 << endl;
    a2.computeShortestPath();
    a2.showPath(cout);
  } 
  catch (string e)
    {
      cerr << "l'erreur \"" << e << "\" s'est produite !" << endl;
    }
  catch (...)
    {
      cerr << "Une exception non identifie s'est produite" << endl;
    }
}


