// Test file for Epsilon-transitions
//

#include "Transducer.h"
#include <iostream>

int
main()
{
  try {
    // Create an Entry Transducer
    EntryTransducer a0;
    EntryNode * n0= a0.getTrueStart();
    EntryNode * n1= a0.makeNodeByLabel(1);
    //  ir:r-A1
    n0->addLink(n1, "A", "A");
    n1->setFinal(true);

    cout << a0 << endl;

    // Create a rule Transducer
    RuleTransducer a3;
    RuleNode * rn0= a3.getStart();
    RuleNode * rn1= a3.makeNodeByLabel(1);
    RuleNode * rn2= a3.makeNodeByLabel(1);
    rn0->addLink(rn1, "epsilon -> epsilon");
    rn1->addLink(rn2, "$X -> 1");
    rn2->setFinal(true);

    // Apply
    CompositeTransducer a4(&a0,&a3);
    a4.computeShortestPath();
    a4.showPath(cout);
  } 
  catch (string e)
    {
      cerr << "l'erreur \"" << e << "\" s'est produite !" << endl;
    }
  catch (...)
    {
      cerr << "Une exception non identifie s'est produite" << endl;
    }
}


